# -*- coding: utf-8 -*-
##------------------------------------------
##  Japanese speaking program  Ver 0.01
##       by Open JTalk platform: windows
##
##               2022.09.13 Masahiro Izutsu
##------------------------------------------
## jtalkw.py

import subprocess
import winsound
from datetime import datetime

HTS_VOICE = ['mei/mei_normal.htsvoice',
             'nitech/nitech_jp_atr503_m001.htsvoice',
             'mei/mei_angry.htsvoice',
             'mei/mei_bashful.htsvoice',
             'mei/mei_happy.htsvoice',
             'mei/mei_sad.htsvoice'
             ]

def jtalk(t, voice = 0, waitf = False):
    # depend on your install folder 
    OPENJTALK_BINPATH = 'c:/open_jtalk/bin'
    OPENJTALK_DICPATH = 'c:/open_jtalk/bin/dic'
    OPENJTALK_VOICEPATH = 'c:/open_jtalk/bin/Voice/' + HTS_VOICE[voice]
    open_jtalk=[OPENJTALK_BINPATH + '/open_jtalk.exe']
    mech=['-x',OPENJTALK_DICPATH]
    htsvoice=['-m',OPENJTALK_VOICEPATH]
    speed=['-r','1.0']
    outwav=['-ow','open_jtalk.wav']
    cmd=open_jtalk+mech+htsvoice+speed+outwav
    c = subprocess.Popen(cmd,stdin=subprocess.PIPE)

    # convert text encoding from utf-8 to shitf-jis
    c.stdin.write(t.encode('shift-jis'))
    c.stdin.close()
    c.wait()

    # play wav audio file with winsound module
    winsound.PlaySound('open_jtalk.wav', winsound.SND_FILENAME)


def say_datetime(voice = 0, waitf = False):
    d = datetime.now()
    text = '%s月%s日、%s時%s分%s秒' % (d.month, d.day, d.hour, d.minute, d.second)
    print(text)
    jtalk(text, voice)

if __name__ == '__main__':
    import sys

    args = sys.argv
    sel = '0' if len(args) <= 1 else args[1]
    voice = int(sel)
    if voice >= len(HTS_VOICE):
        voice = 0

    jtalk(u'オープンジェイトークを使用して日本語を話します', voice) 
    say_datetime(voice)
