# -*- coding: utf-8 -*-
##------------------------------------------
##   My GUI moving ialog             Ver 0.03
##
##               2022.07.06 Masahiro Izutsu
##------------------------------------------
## my_movdlge.py
##  ver 0.02    2022.07.16      入力ダイアログの初期値
##  ver 0.03    2022.10.14      入力ダイアログ2 追加

import tkinter

# 「情報」メッセージ・ダイアログ
#       out:    'ok'
#
def info_dialog(title, msg, x = -1, y = -1):
    global result
    result = None                                       # 戻り値
    dlg_w = 340                                         # ダイアログの幅
    dlg_h = 106                                         # 　　　　　　高さ

    # 'ok' イベント・ハンドラ
    def ok_button():
        global result
        result = 'ok'
        root.destroy()

    # キー・イベント・ハンドラ
    def input_key(event):
        global result
        key_name = event.keysym
        if key_name == 'Escape':
            result = ''
            root.destroy()
        elif key_name == 'Return':
            result = 'ok'
            root.destroy()

    # ダイアログ・メイン
    dlg_x, dlg_y = _get_dialog_offset(dlg_w, dlg_h, x, y)
    root = tkinter.Tk()
    root.title(title)
    root.geometry(f'{dlg_w}x{dlg_h}+{dlg_x}+{dlg_y}')

    label_msg = tkinter.Label(text = msg)
    label_msg.pack(pady = 20)
    button1 = tkinter.Button(text='OK', width = 6, command=lambda:ok_button())
    button1.pack()
    root.bind("<KeyPress>", input_key)

    # フォーカス設定
    button1.focus_set()

    root.mainloop()
    return result

# 「はい・いいえ」メッセージ・ダイアログ
#       out:    True / False
#
def yesno_dialog(title, msg, x = -1, y = -1, btn1 = 'はい', btn2 = 'いいえ'):
    global result, button1
    result = None                                      # 戻り値
    dlg_w = 340                                         # ダイアログの幅
    dlg_h = 106                                         # 　　　　　　高さ

    # 'OK' イベント・ハンドラ
    def ok_button():
        global result
        result = True
        root.destroy()

    # 'cancel' イベント・ハンドラ
    def cancel_button():
        global result
        result = False
        root.destroy()

    # キー・イベント・ハンドラ
    def input_key(event):
        global result, button1
        key_name = event.keysym
        focus = root.focus_get()
        if key_name == 'Escape':
            result = ''
            root.destroy()
        elif key_name == 'Return' or key_name == 'space':
            result = True if focus == button1 else False
            root.destroy()
        elif key_name == 'y':
            result = True
            root.destroy()
        elif key_name == 'n':
            result = False
            root.destroy()

    # ダイアログ・メイン
    dlg_x, dlg_y = _get_dialog_offset(dlg_w, dlg_h, x, y)
    root = tkinter.Tk()
    root.title(title)
    root.geometry(f'{dlg_w}x{dlg_h}+{dlg_x}+{dlg_y}')

    label_msg = tkinter.Label(text = msg)
    label_msg.pack(pady = 10)
    button1 = tkinter.Button(text=btn1, width = 6, command=lambda:ok_button())
    button1.place(x=90, y=64)
    button2 = tkinter.Button(text=btn2, width = 6, command=lambda:cancel_button())
    button2.place(x=190, y=64)
    root.bind("<KeyPress>", input_key)

    # フォーカス設定
    button1.focus_set()

    root.mainloop()
    return result

# 「Yes・No」メッセージ・ダイアログ
#       out:    'yes' / 'no'
#
def question_dialog(title, msg, x = -1, y = -1):
    global result, button1
    result = None                                      # 戻り値
    dlg_w = 340                                         # ダイアログの幅
    dlg_h = 106                                         # 　　　　　　高さ

    # 'OK' イベント・ハンドラ
    def ok_button():
        global result
        result = 'yes'
        root.destroy()

    # 'cancel' イベント・ハンドラ
    def cancel_button():
        global result
        result = 'no'
        root.destroy()

    # キー・イベント・ハンドラ
    def input_key(event):
        global result, button1
        key_name = event.keysym
        focus = root.focus_get()
        if key_name == 'Escape':
            result = ''
            root.destroy()
        elif key_name == 'Return' or key_name == 'space':
            result = 'yes' if focus == button1 else 'no'
            root.destroy()
        elif key_name == 'y':
            result = 'yes'
            root.destroy()
        elif key_name == 'n':
            result = 'no'
            root.destroy()

    # ダイアログ・メイン
    dlg_x, dlg_y = _get_dialog_offset(dlg_w, dlg_h, x, y)
    root = tkinter.Tk()
    root.title(title)
    root.geometry(f'{dlg_w}x{dlg_h}+{dlg_x}+{dlg_y}')

    label_msg = tkinter.Label(text = msg)
    label_msg.pack(pady = 10)
    button1 = tkinter.Button(text='Yes', width = 6, command=lambda:ok_button())
    button1.place(x=90, y=64)
    button2 = tkinter.Button(text='No', width = 6, command=lambda:cancel_button())
    button2.place(x=190, y=64)
    root.bind("<KeyPress>", input_key)

    # フォーカス設定
    button1.focus_set()

    root.mainloop()
    return result

# 「OK・Cancel」メッセージ・ダイアログ
#       out:    True / False
#
def okcancel_dialog(title, msg, x = -1, y = -1):
    btn1 = 'OK'
    btn2 = 'Cancel'
    return yesno_dialog(title, msg, x, y, btn1, btn2)

# 「再試行・キャンセル」メッセージ・ダイアログ
#       out:    True / False
#
def retrycancel_dialog(title, msg, x = -1, y = -1):
    btn1 = '再試行'
    btn2 = 'キャンセル'
    return yesno_dialog(title, msg, x, y, btn1, btn2)

# 入力ダイアログ
#       out:    入力テキスト or None
#
def input_dialog(title, msg, x = -1, y = -1, init = ''):
    global result
    result = None                                       # 入力テキスト
    dlg_w = 340                                         # ダイアログの幅
    dlg_h = 106                                         # 　　　　　　高さ

    # 'ok' イベント・ハンドラ
    def ok_button():
        global result
        result = entry.get()
        root.destroy()

    # 'cancel' イベント・ハンドラ
    def cancel_button():
        global result
        result = ''
        root.destroy()

    # キー・イベント・ハンドラ
    def input_key(event):
        global result
        key_name = event.keysym
        if key_name == 'Escape':
            result = ""
            root.destroy()
        elif key_name == 'Return':
            result = entry.get()
            root.destroy()

    # ダイアログ・メイン
    dlg_x, dlg_y = _get_dialog_offset(dlg_w, dlg_h, x, y)
    root = tkinter.Tk()
    root.title(title)
    root.geometry(f'{dlg_w}x{dlg_h}+{dlg_x}+{dlg_y}')

    label_msg = tkinter.Label(text = msg)
    label_msg.pack(pady = 10)
    entry = tkinter.Entry(width = 40)
    entry.insert(0,init)
    entry.pack()
    button1 = tkinter.Button(text='OK', width = 6, command=lambda:ok_button())
    button1.place(x=90, y=64)
    button2 = tkinter.Button(text='Cancel', width = 6, command=lambda:cancel_button())
    button2.place(x=190, y=64)
    root.bind("<KeyPress>", input_key)

    # フォーカス設定
    entry.focus_set()
    
    root.mainloop()
    return result

# 入力ダイアログ 2
#       in:     text1, text2    入力名
#               init1,init2     入力テキスト初期値
#       out:    入力テキスト1, 入力テキスト2 or None
#
def input_dialog2(title, msg, x = -1, y = -1, text1 = '1', text2 = '2', init1 = '', init2 = ''):
    global result1, result2
    result1 = None                                      # 入力テキスト1
    result2 = None                                      # 入力テキスト2
    dlg_w = 380                                         # ダイアログの幅
    dlg_h = 146                                         # 　　　　　　高さ

    # 'ok' イベント・ハンドラ
    def ok_button():
        global result1, result2
        result1 = entry1.get()
        result2 = entry2.get()
        root.destroy()

    # 'cancel' イベント・ハンドラ
    def cancel_button():
        global result1, result2
        result1 = ''
        result2 = ''
        root.destroy()

    # キー・イベント・ハンドラ
    def input_key1(event):
        global result1, result2
        key_name = event.keysym
        if key_name == 'Escape':
            result1 = ""
            root.destroy()
        elif key_name == 'Return':
            result1 = entry.get()
            root.destroy()

    # キー・イベント・ハンドラ 2
    def input_key2(event):
        global result1, result2
        key_name = event.keysym
        if key_name == 'Escape':
            result2 = ""
            root.destroy()
        elif key_name == 'Return':
            result2 = entry.get()
            root.destroy()

    # ダイアログ・メイン
    dlg_x, dlg_y = _get_dialog_offset(dlg_w, dlg_h, x, y)
    root = tkinter.Tk()
    root.title(title)
    root.geometry(f'{dlg_w}x{dlg_h}+{dlg_x}+{dlg_y}')

    label_msg = tkinter.Label(text = msg)
    label_msg.pack(pady = 10)
    label_msg = tkinter.Label(text = text1, width = len(text1)+2, height = 1)
    label_msg.place(x = 20, y = 40)
    entry1 = tkinter.Entry(width = 40)
    entry1.insert(0,init1)
    entry1.place(x = 70, y = 40)
    label_msg = tkinter.Label(text = text2, width = len(text1)+2, height = 1)
    label_msg.place(x = 20, y = 64)
    entry2 = tkinter.Entry(width = 40)
    entry2.insert(0,init2)
    entry2.place(x = 70, y = 64)
    button1 = tkinter.Button(text='OK', width = 6, command=lambda:ok_button())
    button1.place(x=90, y=100)
    button2 = tkinter.Button(text='Cancel', width = 6, command=lambda:cancel_button())
    button2.place(x=190, y=100)
    root.bind("<KeyPress>", input_key1)
    root.bind("<KeyPress>", input_key2)

    # フォーカス設定
    entry1.focus_set()
    
    root.mainloop()
    return result1, result2

# スクリーンのサイズを得る
#   out:    height,width
#
def get_display_size():
    root= tkinter.Tk()
    height= root.winfo_screenheight()
    width= root.winfo_screenwidth()
    root.destroy()
    return height, width

# スクリーンの中央配置座標を得る
#   in:     width, height   ダイアログの大きさ
#   out:    xoff, yoff      ダイアログのオフセット位置
#
def get_center_offset(width, height):
    h, w = get_display_size()
    xoff = int((w - width) / 2)
    yoff = int((h - height) / 2)
    return xoff, yoff

# スクリーンの中央配置座標を得る (内部利用)
#   in:     width, height   ダイアログの大きさ
#           x, y            ダイアログの位置指定
#   out:    dlg_x, dlg_y    ダイアログのオフセット位置
#
def _get_dialog_offset(width, height, x, y):
    if x < 0 or y < 0:
        xoff, yoff = get_center_offset(width, height)
        dlg_x = xoff if x < 0 else x
        dlg_y = yoff if y < 0 else y
    else:
        dlg_x = x
        dlg_y = y
    return dlg_x, dlg_y


#-----Test routine-----
# $ python3 my_movdlge.py {option:0/1/2/3/4/5/6/7/8/9}
#
if __name__ == "__main__":
    import sys
    import my_logging

    logger = my_logging.get_module_logger_sel(__name__, 1)
    args = sys.argv
    sel = '0' if len(args) <= 1 else args[1]
    title = "'my_movedlg.py' Test"

    if sel == '0':
        height, width = get_display_size()
        logger.debug(f'get_display_size() height: {height} width: {width}')
    elif sel == '1':
        width = 350
        height = 100
        xoff, yoff = get_center_offset(width, height)
        logger.debug(f'get_center_offset() x-offset: {xoff} y-offset: {yoff}')
    elif sel == '2':
        msg = "'input_dialog' のテスト1"
        x = 300
        y = 50
        ret_str = input_dialog(title, msg, x, y)
        logger.debug(f'input_dialog() retuan value: {ret_str}')
    elif sel == '3':
        msg = "'input_dialog' のテスト2"
        ret_str = input_dialog(title, msg)
        logger.debug(f'input_dialog() retuan value: {ret_str}')
    elif sel == '4':
        msg = "'info_dialog' のテスト"
        ret_str = info_dialog(title, msg)
        logger.debug(f'info_dialog () retuan value: {ret_str}')
    elif sel == '5':
        msg = "'yesno_dialog' のテスト"
        result = yesno_dialog(title, msg)
        logger.debug(f'yesno_dialog () retuan value: {result}')
    elif sel == '6':
        msg = "'question_dialog' のテスト"
        result = question_dialog(title, msg)
        logger.debug(f'question_dialog () retuan value: {result}')
    elif sel == '7':
        msg = "'okcancel_dialog' のテスト"
        result = okcancel_dialog(title, msg)
        logger.debug(f'okcancel_dialog () retuan value: {result}')
    elif sel == '8':
        msg = "'retrycancel_dialog' のテスト"
        result = retrycancel_dialog(title, msg)
        logger.debug(f'retrycancel_dialog () retuan value: {result}')
    elif sel == '9':
        msg = "'input_dialog' のテスト3（初期値あり）"
        ret_str = input_dialog(title, msg, init = '初期値設定')
        logger.debug(f'input_dialog() retuan value: {ret_str}')

    elif sel == '10':
        msg = "'input_dialog' のテスト4（初期値あり）"
        ret_str1, ret_str2 = input_dialog2(title, msg, text1 = 'お名前', text2 = 'ふりがな', init1 = '初期値設定1', init2 = '初期値設定2')
        logger.debug(f'input_dialog() retuan value: {ret_str1}, {ret_str2}')

