# -*- coding: utf-8 -*-
##------------------------------------------
##   My Library process with OpenCV
##
##               2022.07.07 Masahiro Izutsu
##------------------------------------------
## my_process.py            (mylib_pros.py)

import cv2

# アスペクト比を固定して画像をリサイズ
def frame_resize(image, maxsize):
    if maxsize > 300:
        img_h, img_w = image.shape[:2]
        if (img_w > img_h):
            if (img_w > maxsize):
                height = round(img_h * (maxsize / img_w))
                image = cv2.resize(image, dsize = (maxsize, height))
        else:
            if (img_h > maxsize):
                width =  round(img_w * (maxsize / img_h))
                image = cv2.resize(image, dsize = (width, maxsize))
    return image


#-----Test routine-----
# $ python3 my_process.py
#
if __name__ == "__main__":
    import my_winstat

    img = cv2.imread("mylib_test/color_circle.png")
    winname = 'Resize Test'
    cv2.namedWindow(winname, flags=cv2.WINDOW_AUTOSIZE | cv2.WINDOW_GUI_NORMAL) 
    img = frame_resize(img, 400)

    while True:
        cv2.imshow(winname, img)
        key = cv2.waitKey(10)

        if key == 27:
            break

        if not my_winstat._is_visible(winname):
            break

    cv2.destroyWindow(winname)

