# -*- coding: utf-8 -*-
##------------------------------------------
##   My Library win-gui with OpenCV
##
##               2022.07.01 Masahiro Izutsu
##------------------------------------------
## my_winstat.py

import cv2

# ウインドウの状態を調べる (Close 押し下げを感知する)
#   https://louis-needless.hatenablog.com/entry/how_to_close_opencv_window_by_mouse
#
BackendError = type('BackendError', (Exception,), {})
def _is_visible(winname):
    try:
        ret = cv2.getWindowProperty(winname, cv2.WND_PROP_VISIBLE)
        if ret == -1:
            # Qtモジュールが存在しない場合は常にウインドウ有効状態とする
            #raise BackendError('Use Qt as backend to check whether window is visible or not.')
            return True
        return bool(ret)

    except cv2.error:
        return False


#-----Test routine-----
# $ python3 my_winstat.py
#
if __name__ == "__main__":
    img = cv2.imread("mylib_test/color_circle.png")
    winname = 'Close Test'
    cv2.namedWindow(winname, flags=cv2.WINDOW_AUTOSIZE | cv2.WINDOW_GUI_NORMAL) 

    while True:
        cv2.imshow(winname, img)
        key = cv2.waitKey(10)

        if key == 27:
            break

        if not _is_visible(winname):
            break

    cv2.destroyWindow(winname)

